//#include "mUpPile.h"
#include "soap_likes.cpp"
#include "gatk_likes.h"
#include "bam_likes.h"

class gen_likes{
private:
  soap_likes soap;
  int type;
  int doingGLest;//if data needs recalibration, this is set to zero
public:
  int init(bufReader *rd,int nSamples,int type_a);
  double **call_likes(chunkyT *chk);
};

//returnvalue is !=0 if no need for calibrating data
int gen_likes::init(bufReader *rd,int nSamples,int type_a){
  type=type_a;
  fprintf(stderr,"\t genlikes init type=%d\n",type);
  int retVal =1;
  if(type==0){
    fprintf(stderr,"Doing SOAPsnp GL estimates:remember to set -r accordingly\n");
    retVal = soap.init(rd,nSamples);
  }else if(type==1){
    fprintf(stderr,"Doing samtools GL estimates\n");
  }else if(type==2)
    fprintf(stderr,"Doing gatk GL estimates\n");
  else {
    fprintf(stderr,"Unknown GL estimator: %d\n",type);
    fflush(stderr);
    exit(0);
  }
  doingGLest = retVal;
  fprintf(stderr,"perform GL estimation=%d\n",doingGLest);
  return retVal;
}


int refToInt[256] = {
  0,1,2,3,4,4,4,4,4,4,4,4,4,4,4,4,//15
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//31
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//47
  0,1,2,3,4,4,4,4,4,4,4,4,4,4,4,4,//63
  4,0,4,1,4,4,4,2,4,4,4,4,4,4,4,4,//79
  4,4,4,4,3,4,4,4,4,4,4,4,4,4,4,4,//95
  4,0,4,1,4,4,4,2,4,4,4,4,4,4,4,4,//111
  4,4,4,4,3,4,4,4,4,4,4,4,4,4,4,4,//127
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//143
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//159
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//175
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//191
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//207
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//223
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//239
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4//255
};


int verb = 1;

double ** gen_likes::call_likes(chunkyT *chk) {
    double **likes = NULL;
    if(chk!=NULL){
      //      fprintf(stderr,"[%s] regstart=%d regstop=%d nSites=%d\n",__FUNCTION__,chk->regStart,chk->regStop,chk->nSites);
      likes = new double*[chk->nSites];
    }else
      fprintf(stderr,"[%s] recevevied null chunk\n",__FUNCTION__);

    if(type==0){
      if(verb)
	fprintf(stderr,"doing soapsnp model:\n");
      verb = 0;
      //      make_prob(chk);
      soap.run(chk,likes);
      if(doingGLest==0)//we dont estimate GL but make a calibration matrix
	return NULL;
    }else if(type==1){
      if(verb){
	fprintf(stderr,"type=%d is implemented yet doing samtoolsmodel\n",type);
	verb =0;
      }
      call_bam(chk,likes);
    }else if(type==2){
      //fprintf(stderr,"type=%d gatk\n",type);
      call_gatk(chk,likes);
    }
    static FILE *mFile = NULL;
    static FILE *gFile = NULL;
    if(gFile==NULL){
      mFile = fopen("mafs.mafs","w");
      gFile = fopen("glfs.glfs","w");
    }
    if(chk!=NULL){
      for(int i=0;i<chk->nSites;i++)
	fprintf(mFile,"%s\t%d\n",chk->refName,chk->nd[i][0].refPos+1);
      fflush(mFile);
      for(int i=0;i<chk->nSites;i++){
	//	fprintf(stderr,"i=%d\n",i);
	fwrite(likes[i],sizeof(double),10*chk->nSamples,gFile);
      }
    }else{
      fclose(mFile);
      fclose(gFile);
    }
    return likes;
}
