#include <vector>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include "parseArgs_bambi.h"

//daemon/dragon used for selecting only unique hits when doing soapsnp GL estimates. this should be modified.

int uniqueOnly = 0;

//read program parameters
args *getArgs(char **argv){
  args *ret = new args;
  ret->callback= NULL;
  ret->GL = -1;
  ret->uniqueOnly = 0;
  ret->nInd = 0;
  ret->type = 1;
  ret->nLines = 50;
  ret->nThreads = 5;
  ret->inputfile=ret->inputfiles=ret->region=ret->regionfile=NULL;
  if(!strcmp("view",*argv)) ret->jobtype = 1;
  else if(!strcmp("uppile",*argv))  ret->jobtype = 2;
  else{
    fprintf(stderr,"Supply 'view' or 'uppile\n");
    exit(0);
  }
  ++argv;
  while(*argv){
    if(!strcmp("-b",*argv)) ret->inputfiles = *++argv;
    else if(!strcmp("-r",*argv)) ret->region = *++argv;
    else if(!strcmp("-rf",*argv)) ret->regionfile = *++argv;
    else if(!strcmp("-nInd",*argv)) ret->nInd = atoi(*++argv);
    else if(!strcmp("-nLines",*argv)) ret->nLines = atoi(*++argv);
    else if(!strcmp("-nThreads",*argv)) ret->nThreads = atoi(*++argv);
    else if(!strcmp("-type",*argv)) ret->type = atoi(*++argv);
    else if(!strcmp("-GL",*argv)) ret->GL = atoi(*++argv);
    else if(!strcmp("-uniqueOnly",*argv)) ret->uniqueOnly = atoi(*++argv);
    else ret->inputfile = *argv;
    ++argv;
  }
  if(ret->inputfile && ret->inputfile[0]=='-'){
    fprintf(stderr,"[Error] Problem understanding inputfilename: %s\n",ret->inputfile);
    return NULL;
  }
  uniqueOnly = ret->uniqueOnly;
  return ret;
}

void print(args *a,FILE *fp){
  fprintf(fp,"\njobtype=%d, 1=view, 2=uppile\n",a->jobtype);
  fprintf(fp,"type=%d, 0=slow/secure 1=fast/insecure\n",a->type);
  fprintf(fp,"inputfile=%s (single sample)\n",a->inputfile);
  fprintf(fp,"inputfiles=%s (multisample)\n",a->inputfiles);
  fprintf(fp,"region=%s (single region)\n",a->region);
  fprintf(fp,"nInd=%d (single region)\n",a->nInd);
  fprintf(fp,"regionfile=%s (multiregion)\n\n",a->regionfile);
  fprintf(fp,"nLines=%d\tnThreads=%d\n",a->nLines,a->nThreads);
  fprintf(fp,"-GL INT: -1=mpileup 0=soap 1=samtools 2=gatk\n");
}
